/***************************************************************************
 *   Copyright (C) 2009 by Sergey Yakushev                                 *
 *   yakushevs@list.ru                                                     *
 *                                                                         *
 *   This is a plugin generated from the QGIS plugin template              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef VRPPLUGIN_PLUGINGUI_H
#define VRPPLUGIN_PLUGINGUI_H

#include <QDialog>
#include "settings.h"

// forward declaration QT-classes
class QComboBox;
class QLineEdit;
class QSpinBox;
// forward declaration Qgis-classes
class QgsVectorLayer;

/**
@author Sergey Yakushev
*/
class VrpPluginGui : public QDialog
{
    Q_OBJECT
  public:
	VrpPluginGui(const VrpPluginSettings& s,  QWidget* parent = 0, Qt::WFlags fl = 0 );
	~VrpPluginGui();

	/**
	 * return current seleted settings
	 */
	VrpPluginSettings settings();
  private:
    static const int context_id = 0;

  private slots:
	void on_buttonBox_accepted();
	void on_buttonBox_rejected();
	void on_buttonBox_helpRequested();
	void on_mcbLayers_selectItem();

  private:
  	QgsVectorLayer * selectedLayer();

  private:
  	/**
	 * list of passible layers
	 */
  	QComboBox *mcbLayers;
	/**
	 * list of possible fields for use as direction
	 */
	QComboBox *mcbDirection;
	/**
	 * default direction value
	 */
	QComboBox *mcbDirectionDefault;
	/**
	 * list of possible fields for use as speed
	 */
	QComboBox *mcbSpeed;
	/**
	 * Offroad speed
	 */
	QSpinBox *msbOffroadSpeed;
	/**
	 * Default speed value
	 */
	QSpinBox *msbSpeedDefault;
	/**
	 * Unit of speed
	 */
	QComboBox *mcbUnitOfSpeed;
};

#endif
